Index: uspace/lib/softfloat/generic/softfloat.c
===================================================================
--- uspace/lib/softfloat/generic/softfloat.c	(revision e898296dccf506e7ddbab26d669ed48d920be059)
+++ uspace/lib/softfloat/generic/softfloat.c	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
@@ -1,4 +1,5 @@
 /*
  * Copyright (c) 2005 Josef Cejka
+ * Copyright (c) 2011 Petr Koupy
  * All rights reserved.
  *
@@ -32,5 +33,5 @@
  * @{
  */
-/** @file
+/** @file Softfloat API.
  */
 
@@ -83,4 +84,20 @@
 }
 
+long double __addtf3(long double a, long double b)
+{
+	float128 ta, tb;
+	ta.ld = a;
+	tb.ld = b;
+	if (ta.parts.sign != tb.parts.sign) {
+		if (ta.parts.sign) {
+			ta.parts.sign = 0;
+			return subFloat128(tb, ta).ld;
+		};
+		tb.parts.sign = 0;
+		return subFloat128(ta, tb).ld;
+	}
+	return addFloat128(ta, tb).ld;
+}
+
 float __subsf3(float a, float b)
 {
@@ -107,4 +124,16 @@
 }
 
+long double __subtf3(long double a, long double b)
+{
+	float128 ta, tb;
+	ta.ld = a;
+	tb.ld = b;
+	if (ta.parts.sign != tb.parts.sign) {
+		tb.parts.sign = !tb.parts.sign;
+		return addFloat128(ta, tb).ld;
+	}
+	return subFloat128(ta, tb).ld;
+}
+
 float __mulsf3(float a, float b) 
 {
@@ -123,4 +152,12 @@
 }
 
+long double __multf3(long double a, long double b)
+{
+	float128 ta, tb;
+	ta.ld = a;
+	tb.ld = b;
+	return 	mulFloat128(ta, tb).ld;
+}
+
 float __divsf3(float a, float b) 
 {
@@ -139,4 +176,12 @@
 }
 
+long double __divtf3(long double a, long double b)
+{
+	float128 ta, tb;
+	ta.ld = a;
+	tb.ld = b;
+	return 	divFloat128(ta, tb).ld;
+}
+
 float __negsf2(float a)
 {
@@ -149,8 +194,16 @@
 double __negdf2(double a)
 {
-	float64 fa;
-	fa.d = a;
-	fa.parts.sign = !fa.parts.sign;
-	return fa.d;
+	float64 da;
+	da.d = a;
+	da.parts.sign = !da.parts.sign;
+	return da.d;
+}
+
+long double __negtf2(long double a)
+{
+	float128 ta;
+	ta.ld = a;
+	ta.parts.sign = !ta.parts.sign;
+	return ta.ld;
 }
 
@@ -164,4 +217,18 @@
 }
 
+long double __extendsftf2(float a)
+{
+	float32 fa;
+	fa.f = a;
+	return convertFloat32ToFloat128(fa).ld;
+}
+
+long double __extenddftf2(double a)
+{
+	float64 da;
+	da.d = a;
+	return convertFloat64ToFloat128(da).ld;
+}
+
 float __truncdfsf2(double a) 
 {
@@ -171,4 +238,18 @@
 }
 
+float __trunctfsf2(long double a)
+{
+	float128 ta;
+	ta.ld = a;
+	return convertFloat128ToFloat32(ta).f;
+}
+
+double __trunctfdf2(long double a)
+{
+	float128 ta;
+	ta.ld = a;
+	return convertFloat128ToFloat64(ta).d;
+}
+
 int __fixsfsi(float a)
 {
@@ -178,4 +259,5 @@
 	return float32_to_int(fa);
 }
+
 int __fixdfsi(double a)
 {
@@ -184,4 +266,12 @@
 	
 	return float64_to_int(da);
+}
+
+int __fixtfsi(long double a)
+{
+	float128 ta;
+	ta.ld = a;
+
+	return float128_to_int(ta);
 }
  
@@ -193,4 +283,5 @@
 	return float32_to_long(fa);
 }
+
 long __fixdfdi(double a)
 {
@@ -199,4 +290,12 @@
 	
 	return float64_to_long(da);
+}
+
+long __fixtfdi(long double a)
+{
+	float128 ta;
+	ta.ld = a;
+
+	return float128_to_long(ta);
 }
  
@@ -208,4 +307,5 @@
 	return float32_to_longlong(fa);
 }
+
 long long __fixdfti(double a)
 {
@@ -216,4 +316,12 @@
 }
 
+long long __fixtfti(long double a)
+{
+	float128 ta;
+	ta.ld = a;
+
+	return float128_to_longlong(ta);
+}
+
 unsigned int __fixunssfsi(float a)
 {
@@ -223,4 +331,5 @@
 	return float32_to_uint(fa);
 }
+
 unsigned int __fixunsdfsi(double a)
 {
@@ -229,4 +338,12 @@
 	
 	return float64_to_uint(da);
+}
+
+unsigned int __fixunstfsi(long double a)
+{
+	float128 ta;
+	ta.ld = a;
+
+	return float128_to_uint(ta);
 }
  
@@ -238,4 +355,5 @@
 	return float32_to_ulong(fa);
 }
+
 unsigned long __fixunsdfdi(double a)
 {
@@ -244,4 +362,12 @@
 	
 	return float64_to_ulong(da);
+}
+
+unsigned long __fixunstfdi(long double a)
+{
+	float128 ta;
+	ta.ld = a;
+
+	return float128_to_ulong(ta);
 }
  
@@ -253,4 +379,5 @@
 	return float32_to_ulonglong(fa);
 }
+
 unsigned long long __fixunsdfti(double a)
 {
@@ -259,4 +386,12 @@
 	
 	return float64_to_ulonglong(da);
+}
+
+unsigned long long __fixunstfti(long double a)
+{
+	float128 ta;
+	ta.ld = a;
+
+	return float128_to_ulonglong(ta);
 }
  
@@ -268,4 +403,5 @@
 	return fa.f;
 }
+
 double __floatsidf(int i)
 {
@@ -275,4 +411,12 @@
 	return da.d;
 }
+
+long double __floatsitf(int i)
+{
+	float128 ta;
+
+	ta = int_to_float128(i);
+	return ta.ld;
+}
  
 float __floatdisf(long i)
@@ -283,4 +427,5 @@
 	return fa.f;
 }
+
 double __floatdidf(long i)
 {
@@ -290,4 +435,12 @@
 	return da.d;
 }
+
+long double __floatditf(long i)
+{
+	float128 ta;
+
+	ta = long_to_float128(i);
+	return ta.ld;
+}
  
 float __floattisf(long long i)
@@ -298,4 +451,5 @@
 	return fa.f;
 }
+
 double __floattidf(long long i)
 {
@@ -306,4 +460,12 @@
 }
 
+long double __floattitf(long long i)
+{
+	float128 ta;
+
+	ta = longlong_to_float128(i);
+	return ta.ld;
+}
+
 float __floatunsisf(unsigned int i)
 {
@@ -313,4 +475,5 @@
 	return fa.f;
 }
+
 double __floatunsidf(unsigned int i)
 {
@@ -320,4 +483,12 @@
 	return da.d;
 }
+
+long double __floatunsitf(unsigned int i)
+{
+	float128 ta;
+
+	ta = uint_to_float128(i);
+	return ta.ld;
+}
  
 float __floatundisf(unsigned long i)
@@ -328,4 +499,5 @@
 	return fa.f;
 }
+
 double __floatundidf(unsigned long i)
 {
@@ -335,4 +507,12 @@
 	return da.d;
 }
+
+long double __floatunditf(unsigned long i)
+{
+	float128 ta;
+
+	ta = ulong_to_float128(i);
+	return ta.ld;
+}
  
 float __floatuntisf(unsigned long long i)
@@ -343,4 +523,5 @@
 	return fa.f;
 }
+
 double __floatuntidf(unsigned long long i)
 {
@@ -351,11 +532,13 @@
 }
 
+long double __floatuntitf(unsigned long long i)
+{
+	float128 ta;
+
+	ta = ulonglong_to_float128(i);
+	return ta.ld;
+}
+
 /* Comparison functions */
-/* Comparison functions */
-
-/* a<b .. -1
- * a=b ..  0
- * a>b ..  1
- * */
 
 int __cmpsf2(float a, float b) 
@@ -364,19 +547,62 @@
 	fa.f = a;
 	fb.f = b;
-	if ( (isFloat32NaN(fa)) || (isFloat32NaN(fb)) ) {
+
+	if ((isFloat32NaN(fa)) || (isFloat32NaN(fb))) {
 		return 1; /* no special constant for unordered - maybe signaled? */
-	};
-
+	}
 	
 	if (isFloat32eq(fa, fb)) {
 		return 0;
-	};
+	}
 	
 	if (isFloat32lt(fa, fb)) {
 		return -1;
-		};
+	}
+
 	return 1;
 }
 
+int __cmpdf2(double a, double b)
+{
+	float64 da, db;
+	da.d = a;
+	db.d = b;
+
+	if ((isFloat64NaN(da)) || (isFloat64NaN(db))) {
+		return 1; /* no special constant for unordered - maybe signaled? */
+	}
+
+	if (isFloat64eq(da, db)) {
+		return 0;
+	}
+
+	if (isFloat64lt(da, db)) {
+		return -1;
+	}
+
+	return 1;
+}
+
+int __cmptf2(long double a, long double b)
+{
+	float128 ta, tb;
+	ta.ld = a;
+	tb.ld = b;
+
+	if ((isFloat128NaN(ta)) || (isFloat128NaN(tb))) {
+		return 1; /* no special constant for unordered - maybe signaled? */
+	}
+
+	if (isFloat128eq(ta, tb)) {
+		return 0;
+	}
+
+	if (isFloat128lt(ta, tb)) {
+		return -1;
+	}
+
+	return 1;
+}
+
 int __unordsf2(float a, float b) 
 {
@@ -384,10 +610,23 @@
 	fa.f = a;
 	fb.f = b;
-	return ( (isFloat32NaN(fa)) || (isFloat32NaN(fb)) );
-}
-
-/** 
- * @return zero, if neither argument is a NaN and are equal
- * */
+	return ((isFloat32NaN(fa)) || (isFloat32NaN(fb)));
+}
+
+int __unorddf2(double a, double b)
+{
+	float64 da, db;
+	da.d = a;
+	db.d = b;
+	return ((isFloat64NaN(da)) || (isFloat64NaN(db)));
+}
+
+int __unordtf2(long double a, long double b)
+{
+	float128 ta, tb;
+	ta.ld = a;
+	tb.ld = b;
+	return ((isFloat128NaN(ta)) || (isFloat128NaN(tb)));
+}
+
 int __eqsf2(float a, float b) 
 {
@@ -395,18 +634,53 @@
 	fa.f = a;
 	fb.f = b;
-	if ( (isFloat32NaN(fa)) || (isFloat32NaN(fb)) ) {
-		/* TODO: sigNaNs*/
-		return 1;
-		};
+	if ((isFloat32NaN(fa)) || (isFloat32NaN(fb))) {
+		/* TODO: sigNaNs */
+		return 1;
+	}
 	return isFloat32eq(fa, fb) - 1;
 }
 
-/* strange behavior, but it was in gcc documentation */
+int __eqdf2(double a, double b)
+{
+	float64 da, db;
+	da.d = a;
+	db.d = b;
+	if ((isFloat64NaN(da)) || (isFloat64NaN(db))) {
+		/* TODO: sigNaNs */
+		return 1;
+	}
+	return isFloat64eq(da, db) - 1;
+}
+
+int __eqtf2(long double a, long double b)
+{
+	float128 ta, tb;
+	ta.ld = a;
+	tb.ld = b;
+	if ((isFloat128NaN(ta)) || (isFloat128NaN(tb))) {
+		/* TODO: sigNaNs */
+		return 1;
+	}
+	return isFloat128eq(ta, tb) - 1;
+}
+
 int __nesf2(float a, float b) 
 {
+	/* strange behavior, but it was in gcc documentation */
 	return __eqsf2(a, b);
 }
 
-/* return value >= 0 if a>=b and neither is NaN */
+int __nedf2(double a, double b)
+{
+	/* strange behavior, but it was in gcc documentation */
+	return __eqdf2(a, b);
+}
+
+int __netf2(long double a, long double b)
+{
+	/* strange behavior, but it was in gcc documentation */
+	return __eqtf2(a, b);
+}
+
 int __gesf2(float a, float b)
 {
@@ -414,21 +688,65 @@
 	fa.f = a;
 	fb.f = b;
-	if ( (isFloat32NaN(fa)) || (isFloat32NaN(fb)) ) {
-		/* TODO: sigNaNs*/
-		return -1;
-		};
+
+	if ((isFloat32NaN(fa)) || (isFloat32NaN(fb))) {
+		/* TODO: sigNaNs */
+		return -1;
+	}
 	
 	if (isFloat32eq(fa, fb)) {
 		return 0;
-	};
+	}
 	
 	if (isFloat32gt(fa, fb)) {
 		return 1;
-		};
+	}
 	
 	return -1;
 }
 
-/** Return negative value, if a<b and neither is NaN*/
+int __gedf2(double a, double b)
+{
+	float64 da, db;
+	da.d = a;
+	db.d = b;
+
+	if ((isFloat64NaN(da)) || (isFloat64NaN(db))) {
+		/* TODO: sigNaNs */
+		return -1;
+	}
+
+	if (isFloat64eq(da, db)) {
+		return 0;
+	}
+
+	if (isFloat64gt(da, db)) {
+		return 1;
+	}
+
+	return -1;
+}
+
+int __getf2(long double a, long double b)
+{
+	float128 ta, tb;
+	ta.ld = a;
+	tb.ld = b;
+
+	if ((isFloat128NaN(ta)) || (isFloat128NaN(tb))) {
+		/* TODO: sigNaNs */
+		return -1;
+	}
+
+	if (isFloat128eq(ta, tb)) {
+		return 0;
+	}
+
+	if (isFloat128gt(ta, tb)) {
+		return 1;
+	}
+
+	return -1;
+}
+
 int __ltsf2(float a, float b)
 {
@@ -436,15 +754,53 @@
 	fa.f = a;
 	fb.f = b;
-	if ( (isFloat32NaN(fa)) || (isFloat32NaN(fb)) ) {
-		/* TODO: sigNaNs*/
-		return 1;
-		};
+
+	if ((isFloat32NaN(fa)) || (isFloat32NaN(fb))) {
+		/* TODO: sigNaNs */
+		return 1;
+	}
+
 	if (isFloat32lt(fa, fb)) {
 		return -1;
-		};
+	}
+
 	return 0;
 }
 
-/* return value <= 0 if a<=b and neither is NaN */
+int __ltdf2(double a, double b)
+{
+	float64 da, db;
+	da.d = a;
+	db.d = b;
+
+	if ((isFloat64NaN(da)) || (isFloat64NaN(db))) {
+		/* TODO: sigNaNs */
+		return 1;
+	}
+
+	if (isFloat64lt(da, db)) {
+		return -1;
+	}
+
+	return 0;
+}
+
+int __lttf2(long double a, long double b)
+{
+	float128 ta, tb;
+	ta.ld = a;
+	tb.ld = b;
+
+	if ((isFloat128NaN(ta)) || (isFloat128NaN(tb))) {
+		/* TODO: sigNaNs */
+		return 1;
+	}
+
+	if (isFloat128lt(ta, tb)) {
+		return -1;
+	}
+
+	return 0;
+}
+
 int __lesf2(float a, float b)
 {
@@ -452,21 +808,65 @@
 	fa.f = a;
 	fb.f = b;
-	if ( (isFloat32NaN(fa)) || (isFloat32NaN(fb)) ) {
-		/* TODO: sigNaNs*/
-		return 1;
-		};
+
+	if ((isFloat32NaN(fa)) || (isFloat32NaN(fb))) {
+		/* TODO: sigNaNs */
+		return 1;
+	}
 	
 	if (isFloat32eq(fa, fb)) {
 		return 0;
-	};
+	}
 	
 	if (isFloat32lt(fa, fb)) {
 		return -1;
-		};
+	}
 	
 	return 1;
 }
 
-/** Return positive value, if a>b and neither is NaN*/
+int __ledf2(double a, double b)
+{
+	float64 da, db;
+	da.d = a;
+	db.d = b;
+
+	if ((isFloat64NaN(da)) || (isFloat64NaN(db))) {
+		/* TODO: sigNaNs */
+		return 1;
+	}
+
+	if (isFloat64eq(da, db)) {
+		return 0;
+	}
+
+	if (isFloat64lt(da, db)) {
+		return -1;
+	}
+
+	return 1;
+}
+
+int __letf2(long double a, long double b)
+{
+	float128 ta, tb;
+	ta.ld = a;
+	tb.ld = b;
+
+	if ((isFloat128NaN(ta)) || (isFloat128NaN(tb))) {
+		/* TODO: sigNaNs */
+		return 1;
+	}
+
+	if (isFloat128eq(ta, tb)) {
+		return 0;
+	}
+
+	if (isFloat128lt(ta, tb)) {
+		return -1;
+	}
+
+	return 1;
+}
+
 int __gtsf2(float a, float b)
 {
@@ -474,23 +874,250 @@
 	fa.f = a;
 	fb.f = b;
-	if ( (isFloat32NaN(fa)) || (isFloat32NaN(fb)) ) {
-		/* TODO: sigNaNs*/
-		return -1;
-		};
+
+	if ((isFloat32NaN(fa)) || (isFloat32NaN(fb))) {
+		/* TODO: sigNaNs */
+		return -1;
+	}
+
 	if (isFloat32gt(fa, fb)) {
 		return 1;
-		};
+	}
+
 	return 0;
 }
 
-/* Other functions */
-
-float __powisf2(float a, int b)
-{
-/* TODO: */
-	float32 fa;
-	fa.binary = FLOAT32_NAN;
-	return fa.f;
-}
+int __gtdf2(double a, double b)
+{
+	float64 da, db;
+	da.d = a;
+	db.d = b;
+
+	if ((isFloat64NaN(da)) || (isFloat64NaN(db))) {
+		/* TODO: sigNaNs */
+		return -1;
+	}
+
+	if (isFloat64gt(da, db)) {
+		return 1;
+	}
+
+	return 0;
+}
+
+int __gttf2(long double a, long double b)
+{
+	float128 ta, tb;
+	ta.ld = a;
+	tb.ld = b;
+
+	if ((isFloat128NaN(ta)) || (isFloat128NaN(tb))) {
+		/* TODO: sigNaNs */
+		return -1;
+	}
+
+	if (isFloat128gt(ta, tb)) {
+		return 1;
+	}
+
+	return 0;
+}
+
+
+
+#ifdef SPARC_SOFTFLOAT
+
+/* SPARC quadruple-precision wrappers */
+
+void _Qp_add(long double *c, long double *a, long double *b)
+{
+	*c = __addtf3(*a, *b);
+}
+
+void _Qp_sub(long double *c, long double *a, long double *b)
+{
+	*c = __subtf3(*a, *b);
+}
+
+void _Qp_mul(long double *c, long double *a, long double *b)
+{
+	*c = __multf3(*a, *b);
+}
+
+void _Qp_div(long double *c, long double *a, long double *b)
+{
+	*c = __divtf3(*a, *b);
+}
+
+void _Qp_neg(long double *c, long double *a)
+{
+	*c = __negtf2(*a);
+}
+
+void _Qp_stoq(long double *c, float a)
+{
+	*c = __extendsftf2(a);
+}
+
+void _Qp_dtoq(long double *c, double a)
+{
+	*c = __extenddftf2(a);
+}
+
+float _Qp_qtos(long double *a)
+{
+	return __trunctfsf2(*a);
+}
+
+double _Qp_qtod(long double *a)
+{
+	return __trunctfdf2(*a);
+}
+
+int _Qp_qtoi(long double *a)
+{
+	return __fixtfsi(*a);
+}
+
+unsigned int _Qp_qtoui(long double *a)
+{
+	return __fixunstfsi(*a);
+}
+
+long _Qp_qtox(long double *a)
+{
+	return __fixtfdi(*a);
+}
+
+unsigned long _Qp_qtoux(long double *a)
+{
+	return __fixunstfdi(*a);
+}
+
+void _Qp_itoq(long double *c, int a)
+{
+	*c = __floatsitf(a);
+}
+
+void _Qp_uitoq(long double *c, unsigned int a)
+{
+	*c = __floatunsitf(a);
+}
+
+void _Qp_xtoq(long double *c, long a)
+{
+	*c = __floatditf(a);
+}
+
+void _Qp_uxtoq(long double *c, unsigned long a)
+{
+	*c = __floatunditf(a);
+}
+
+int _Qp_cmp(long double *a, long double *b)
+{
+	float128 ta, tb;
+	ta.ld = *a;
+	tb.ld = *b;
+
+	if ((isFloat128NaN(ta)) || (isFloat128NaN(tb))) {
+		return 3;
+	}
+
+	if (isFloat128eq(ta, tb)) {
+		return 0;
+	}
+
+	if (isFloat128lt(ta, tb)) {
+		return 1;
+	}
+
+	return 2;
+}
+
+int _Qp_cmpe(long double *a, long double *b)
+{
+	/* strange, but is defined this way in SPARC Compliance Definition */
+	return _Qp_cmp(a, b);
+}
+
+int _Qp_feq(long double *a, long double *b)
+{
+	float128 ta, tb;
+	ta.ld = *a;
+	tb.ld = *b;
+
+	if ((isFloat128NaN(ta)) || (isFloat128NaN(tb))) {
+		return 0;
+	}
+
+	return isFloat128eq(ta, tb);
+}
+
+int _Qp_fge(long double *a, long double *b)
+{
+	float128 ta, tb;
+	ta.ld = *a;
+	tb.ld = *b;
+
+	if ((isFloat128NaN(ta)) || (isFloat128NaN(tb))) {
+		return 0;
+	}
+
+	return isFloat128eq(ta, tb) || isFloat128gt(ta, tb);
+}
+
+int _Qp_fgt(long double *a, long double *b)
+{
+	float128 ta, tb;
+	ta.ld = *a;
+	tb.ld = *b;
+
+	if ((isFloat128NaN(ta)) || (isFloat128NaN(tb))) {
+		return 0;
+	}
+
+	return isFloat128gt(ta, tb);
+}
+
+int _Qp_fle(long double*a, long double *b)
+{
+	float128 ta, tb;
+	ta.ld = *a;
+	tb.ld = *b;
+
+	if ((isFloat128NaN(ta)) || (isFloat128NaN(tb))) {
+		return 0;
+	}
+
+	return isFloat128eq(ta, tb) || isFloat128lt(ta, tb);
+}
+
+int _Qp_flt(long double *a, long double *b)
+{
+	float128 ta, tb;
+	ta.ld = *a;
+	tb.ld = *b;
+
+	if ((isFloat128NaN(ta)) || (isFloat128NaN(tb))) {
+		return 0;
+	}
+
+	return isFloat128lt(ta, tb);
+}
+
+int _Qp_fne(long double *a, long double *b)
+{
+	float128 ta, tb;
+	ta.ld = *a;
+	tb.ld = *b;
+
+	if ((isFloat128NaN(ta)) || (isFloat128NaN(tb))) {
+		return 1;
+	}
+
+	return !isFloat128eq(ta, tb);
+}
+
+#endif
 
 /** @}
Index: uspace/lib/softfloat/generic/sub.c
===================================================================
--- uspace/lib/softfloat/generic/sub.c	(revision e898296dccf506e7ddbab26d669ed48d920be059)
+++ uspace/lib/softfloat/generic/sub.c	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
@@ -1,4 +1,5 @@
 /*
  * Copyright (c) 2005 Josef Cejka
+ * Copyright (c) 2011 Petr Koupy
  * All rights reserved.
  *
@@ -30,5 +31,5 @@
  * @{
  */
-/** @file
+/** @file Substraction functions.
  */
 
@@ -36,6 +37,12 @@
 #include <sub.h>
 #include <comparison.h>
-
-/** Subtract two float32 numbers with same signs
+#include <common.h>
+
+/**
+ * Subtract two single-precision floats with the same signs.
+ *
+ * @param a First input operand.
+ * @param b Second input operand.
+ * @return Result of substraction.
  */
 float32 subFloat32(float32 a, float32 b)
@@ -52,7 +59,7 @@
 			/* TODO: fix SigNaN */
 			if (isFloat32SigNaN(b)) {
-			};
-			return b;
-		};
+			}
+			return b;
+		}
 		
 		if (b.parts.exp == FLOAT32_MAX_EXPONENT) { 
@@ -72,7 +79,7 @@
 			/* TODO: fix SigNaN */
 			if (isFloat32SigNaN(a) || isFloat32SigNaN(b)) {
-			};
-			return a;
-		};
+			}
+			return a;
+		}
 		
 		if (a.parts.exp == FLOAT32_MAX_EXPONENT) { 
@@ -82,5 +89,5 @@
 				result.binary = FLOAT32_NAN;
 				return result;
-			};
+			}
 			return a;
 		}
@@ -92,16 +99,16 @@
 		frac2 = b.parts.fraction;
 		exp2 = b.parts.exp;	
-	};
+	}
 	
 	if (exp1 == 0) {
 		/* both are denormalized */
-		result.parts.fraction = frac1-frac2;
+		result.parts.fraction = frac1 - frac2;
 		if (result.parts.fraction > frac1) {
 			/* TODO: underflow exception */
 			return result;
-		};
+		}
 		result.parts.exp = 0;
 		return result;
-	};
+	}
 
 	/* add hidden bit */
@@ -114,5 +121,5 @@
 		/* normalized */
 		frac2 |= FLOAT32_HIDDEN_BIT_MASK;
-	};
+	}
 	
 	/* create some space for rounding */
@@ -121,8 +128,9 @@
 	
 	if (expdiff > FLOAT32_FRACTION_SIZE + 1) {
-	     goto done;	
-	     };
+		goto done;
+	}
 	
 	frac1 = frac1 - (frac2 >> expdiff);
+
 done:
 	/* TODO: find first nonzero digit and shift result and detect possibly underflow */
@@ -130,6 +138,6 @@
 		--exp1;
 		frac1 <<= 1;
-			/* TODO: fix underflow - frac1 == 0 does not necessary means underflow... */
-	};
+		/* TODO: fix underflow - frac1 == 0 does not necessary means underflow... */
+	}
 	
 	/* rounding - if first bit after fraction is set then round up */
@@ -139,7 +147,7 @@
 		++exp1;
 		frac1 >>= 1;
-	};
-	
-	/*Clear hidden bit and shift */
+	}
+	
+	/* Clear hidden bit and shift */
 	result.parts.fraction = ((frac1 >> 6) & (~FLOAT32_HIDDEN_BIT_MASK)); 
 	result.parts.exp = exp1;
@@ -148,5 +156,10 @@
 }
 
-/** Subtract two float64 numbers with same signs
+/**
+ * Subtract two double-precision floats with the same signs.
+ *
+ * @param a First input operand.
+ * @param b Second input operand.
+ * @return Result of substraction.
  */
 float64 subFloat64(float64 a, float64 b)
@@ -164,7 +177,7 @@
 			/* TODO: fix SigNaN */
 			if (isFloat64SigNaN(b)) {
-			};
-			return b;
-		};
+			}
+			return b;
+		}
 		
 		if (b.parts.exp == FLOAT64_MAX_EXPONENT) { 
@@ -184,7 +197,7 @@
 			/* TODO: fix SigNaN */
 			if (isFloat64SigNaN(a) || isFloat64SigNaN(b)) {
-			};
-			return a;
-		};
+			}
+			return a;
+		}
 		
 		if (a.parts.exp == FLOAT64_MAX_EXPONENT) { 
@@ -194,5 +207,5 @@
 				result.binary = FLOAT64_NAN;
 				return result;
-			};
+			}
 			return a;
 		}
@@ -204,5 +217,5 @@
 		frac2 = b.parts.fraction;
 		exp2 = b.parts.exp;	
-	};
+	}
 	
 	if (exp1 == 0) {
@@ -212,8 +225,8 @@
 			/* TODO: underflow exception */
 			return result;
-		};
+		}
 		result.parts.exp = 0;
 		return result;
-	};
+	}
 
 	/* add hidden bit */
@@ -226,5 +239,5 @@
 		/* normalized */
 		frac2 |= FLOAT64_HIDDEN_BIT_MASK;
-	};
+	}
 	
 	/* create some space for rounding */
@@ -233,8 +246,9 @@
 	
 	if (expdiff > FLOAT64_FRACTION_SIZE + 1) {
-	     goto done;	
-	     };
+		goto done;
+	}
 	
 	frac1 = frac1 - (frac2 >> expdiff);
+
 done:
 	/* TODO: find first nonzero digit and shift result and detect possibly underflow */
@@ -242,6 +256,6 @@
 		--exp1;
 		frac1 <<= 1;
-			/* TODO: fix underflow - frac1 == 0 does not necessary means underflow... */
-	};
+		/* TODO: fix underflow - frac1 == 0 does not necessary means underflow... */
+	}
 	
 	/* rounding - if first bit after fraction is set then round up */
@@ -251,7 +265,7 @@
 		++exp1;
 		frac1 >>= 1;
-	};
-	
-	/*Clear hidden bit and shift */
+	}
+	
+	/* Clear hidden bit and shift */
 	result.parts.fraction = ((frac1 >> 6) & (~FLOAT64_HIDDEN_BIT_MASK)); 
 	result.parts.exp = exp1;
@@ -260,4 +274,152 @@
 }
 
+/**
+ * Subtract two quadruple-precision floats with the same signs.
+ *
+ * @param a First input operand.
+ * @param b Second input operand.
+ * @return Result of substraction.
+ */
+float128 subFloat128(float128 a, float128 b)
+{
+	int expdiff;
+	uint32_t exp1, exp2;
+	uint64_t frac1_hi, frac1_lo, frac2_hi, frac2_lo, tmp_hi, tmp_lo;
+	float128 result;
+
+	result.binary.hi = 0;
+	result.binary.lo = 0;
+
+	expdiff = a.parts.exp - b.parts.exp;
+	if ((expdiff < 0 ) || ((expdiff == 0) &&
+	    lt128(a.parts.frac_hi, a.parts.frac_lo, b.parts.frac_hi, b.parts.frac_lo))) {
+		if (isFloat128NaN(b)) {
+			/* TODO: fix SigNaN */
+			if (isFloat128SigNaN(b)) {
+			}
+			return b;
+		}
+
+		if (b.parts.exp == FLOAT128_MAX_EXPONENT) {
+			b.parts.sign = !b.parts.sign; /* num -(+-inf) = -+inf */
+			return b;
+		}
+
+		result.parts.sign = !a.parts.sign;
+
+		frac1_hi = b.parts.frac_hi;
+		frac1_lo = b.parts.frac_lo;
+		exp1 = b.parts.exp;
+		frac2_hi = a.parts.frac_hi;
+		frac2_lo = a.parts.frac_lo;
+		exp2 = a.parts.exp;
+		expdiff *= -1;
+	} else {
+		if (isFloat128NaN(a)) {
+			/* TODO: fix SigNaN */
+			if (isFloat128SigNaN(a) || isFloat128SigNaN(b)) {
+			}
+			return a;
+		}
+
+		if (a.parts.exp == FLOAT128_MAX_EXPONENT) {
+			if (b.parts.exp == FLOAT128_MAX_EXPONENT) {
+				/* inf - inf => nan */
+				/* TODO: fix exception */
+				result.binary.hi = FLOAT128_NAN_HI;
+				result.binary.lo = FLOAT128_NAN_LO;
+				return result;
+			}
+			return a;
+		}
+
+		result.parts.sign = a.parts.sign;
+
+		frac1_hi = a.parts.frac_hi;
+		frac1_lo = a.parts.frac_lo;
+		exp1 = a.parts.exp;
+		frac2_hi = b.parts.frac_hi;
+		frac2_lo = b.parts.frac_lo;
+		exp2 = b.parts.exp;
+	}
+
+	if (exp1 == 0) {
+		/* both are denormalized */
+		sub128(frac1_hi, frac1_lo, frac2_hi, frac2_lo, &tmp_hi, &tmp_lo);
+		result.parts.frac_hi = tmp_hi;
+		result.parts.frac_lo = tmp_lo;
+		if (lt128(frac1_hi, frac1_lo, result.parts.frac_hi, result.parts.frac_lo)) {
+			/* TODO: underflow exception */
+			return result;
+		}
+		result.parts.exp = 0;
+		return result;
+	}
+
+	/* add hidden bit */
+	or128(frac1_hi, frac1_lo,
+	    FLOAT128_HIDDEN_BIT_MASK_HI, FLOAT128_HIDDEN_BIT_MASK_LO,
+	    &frac1_hi, &frac1_lo);
+
+	if (exp2 == 0) {
+		/* denormalized */
+		--expdiff;
+	} else {
+		/* normalized */
+		or128(frac2_hi, frac2_lo,
+		    FLOAT128_HIDDEN_BIT_MASK_HI, FLOAT128_HIDDEN_BIT_MASK_LO,
+		    &frac2_hi, &frac2_lo);
+	}
+
+	/* create some space for rounding */
+	lshift128(frac1_hi, frac1_lo, 6, &frac1_hi, &frac1_lo);
+	lshift128(frac2_hi, frac2_lo, 6, &frac2_hi, &frac2_lo);
+
+	if (expdiff > FLOAT128_FRACTION_SIZE + 1) {
+		goto done;
+	}
+
+	rshift128(frac2_hi, frac2_lo, expdiff, &tmp_hi, &tmp_lo);
+	sub128(frac1_hi, frac1_lo, tmp_hi, tmp_lo, &frac1_hi, &frac1_lo);
+
+done:
+	/* TODO: find first nonzero digit and shift result and detect possibly underflow */
+	lshift128(FLOAT128_HIDDEN_BIT_MASK_HI, FLOAT128_HIDDEN_BIT_MASK_LO, 6,
+	    &tmp_hi, &tmp_lo);
+	and128(frac1_hi, frac1_lo, tmp_hi, tmp_lo, &tmp_hi, &tmp_lo);
+	while ((exp1 > 0) && (!lt128(0x0ll, 0x0ll, tmp_hi, tmp_lo))) {
+		--exp1;
+		lshift128(frac1_hi, frac1_lo, 1, &frac1_hi, &frac1_lo);
+		/* TODO: fix underflow - frac1 == 0 does not necessary means underflow... */
+
+		lshift128(FLOAT128_HIDDEN_BIT_MASK_HI, FLOAT128_HIDDEN_BIT_MASK_LO, 6,
+		    &tmp_hi, &tmp_lo);
+		and128(frac1_hi, frac1_lo, tmp_hi, tmp_lo, &tmp_hi, &tmp_lo);
+	}
+
+	/* rounding - if first bit after fraction is set then round up */
+	add128(frac1_hi, frac1_lo, 0x0ll, 0x20ll, &frac1_hi, &frac1_lo);
+
+	lshift128(FLOAT128_HIDDEN_BIT_MASK_HI, FLOAT128_HIDDEN_BIT_MASK_LO, 7,
+	   &tmp_hi, &tmp_lo);
+	and128(frac1_hi, frac1_lo, tmp_hi, tmp_lo, &tmp_hi, &tmp_lo);
+	if (lt128(0x0ll, 0x0ll, tmp_hi, tmp_lo)) {
+		++exp1;
+		rshift128(frac1_hi, frac1_lo, 1, &frac1_hi, &frac1_lo);
+	}
+
+	/* Clear hidden bit and shift */
+	rshift128(frac1_hi, frac1_lo, 6, &frac1_hi, &frac1_lo);
+	not128(FLOAT128_HIDDEN_BIT_MASK_HI, FLOAT128_HIDDEN_BIT_MASK_LO,
+	    &tmp_hi, &tmp_lo);
+	and128(frac1_hi, frac1_lo, tmp_hi, tmp_lo, &tmp_hi, &tmp_lo);
+	result.parts.frac_hi = tmp_hi;
+	result.parts.frac_lo = tmp_lo;
+
+	result.parts.exp = exp1;
+
+	return result;
+}
+
 /** @}
  */
Index: uspace/lib/softfloat/include/add.h
===================================================================
--- uspace/lib/softfloat/include/add.h	(revision e898296dccf506e7ddbab26d669ed48d920be059)
+++ uspace/lib/softfloat/include/add.h	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
@@ -1,4 +1,5 @@
 /*
  * Copyright (c) 2005 Josef Cejka
+ * Copyright (c) 2011 Petr Koupy
  * All rights reserved.
  *
@@ -30,5 +31,5 @@
  * @{
  */
-/** @file
+/** @file Addition functions.
  */
 
@@ -38,4 +39,5 @@
 extern float32 addFloat32(float32, float32);
 extern float64 addFloat64(float64, float64);
+extern float128 addFloat128(float128, float128);
 
 #endif
Index: uspace/lib/softfloat/include/common.h
===================================================================
--- uspace/lib/softfloat/include/common.h	(revision e898296dccf506e7ddbab26d669ed48d920be059)
+++ uspace/lib/softfloat/include/common.h	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
@@ -1,4 +1,5 @@
 /*
  * Copyright (c) 2005 Josef Cejka
+ * Copyright (c) 2011 Petr Koupy
  * All rights reserved.
  *
@@ -30,5 +31,5 @@
  * @{
  */
-/** @file
+/** @file Common helper operations.
  */
 
@@ -39,11 +40,34 @@
 
 extern float64 finishFloat64(int32_t, uint64_t, char);
+extern float128 finishFloat128(int32_t, uint64_t, uint64_t, char, uint64_t);
 
+extern int countZeroes8(uint8_t);
+extern int countZeroes32(uint32_t);
 extern int countZeroes64(uint64_t);
-extern int countZeroes32(uint32_t);
-extern int countZeroes8(uint8_t);
 
 extern void roundFloat32(int32_t *, uint32_t *);
 extern void roundFloat64(int32_t *, uint64_t *);
+extern void roundFloat128(int32_t *, uint64_t *, uint64_t *);
+
+extern void lshift128(uint64_t, uint64_t, int, uint64_t *, uint64_t *);
+extern void rshift128(uint64_t, uint64_t, int, uint64_t *, uint64_t *);
+
+extern void and128(uint64_t, uint64_t, uint64_t, uint64_t, uint64_t *, uint64_t *);
+extern void or128(uint64_t, uint64_t, uint64_t, uint64_t, uint64_t *, uint64_t *);
+extern void xor128(uint64_t, uint64_t, uint64_t, uint64_t, uint64_t *, uint64_t *);
+extern void not128(uint64_t, uint64_t, uint64_t *, uint64_t *);
+
+extern int eq128(uint64_t, uint64_t, uint64_t, uint64_t);
+extern int le128(uint64_t, uint64_t, uint64_t, uint64_t);
+extern int lt128(uint64_t, uint64_t, uint64_t, uint64_t);
+
+extern void add128(uint64_t, uint64_t, uint64_t, uint64_t, uint64_t *, uint64_t *);
+extern void sub128(uint64_t, uint64_t, uint64_t, uint64_t, uint64_t *, uint64_t *);
+
+extern void mul64(uint64_t, uint64_t, uint64_t *, uint64_t *);
+extern void mul128(uint64_t, uint64_t, uint64_t, uint64_t,
+    uint64_t *, uint64_t *, uint64_t *, uint64_t *);
+
+extern uint64_t div128est(uint64_t, uint64_t, uint64_t);
 
 #endif
Index: uspace/lib/softfloat/include/comparison.h
===================================================================
--- uspace/lib/softfloat/include/comparison.h	(revision e898296dccf506e7ddbab26d669ed48d920be059)
+++ uspace/lib/softfloat/include/comparison.h	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
@@ -1,4 +1,5 @@
 /*
  * Copyright (c) 2005 Josef Cejka
+ * Copyright (c) 2011 Petr Koupy
  * All rights reserved.
  *
@@ -30,5 +31,5 @@
  * @{
  */
-/** @file
+/** @file Comparison functions.
  */
 
@@ -42,4 +43,8 @@
 extern int isFloat32Zero(float32);
 
+extern int isFloat32eq(float32, float32);
+extern int isFloat32lt(float32, float32);
+extern int isFloat32gt(float32, float32);
+
 extern int isFloat64NaN(float64);
 extern int isFloat64SigNaN(float64);
@@ -48,7 +53,17 @@
 extern int isFloat64Zero(float64);
 
-extern int isFloat32eq(float32, float32);
-extern int isFloat32lt(float32, float32);
-extern int isFloat32gt(float32, float32);
+extern int isFloat64eq(float64, float64);
+extern int isFloat64lt(float64, float64);
+extern int isFloat64gt(float64, float64);
+
+extern int isFloat128NaN(float128);
+extern int isFloat128SigNaN(float128);
+
+extern int isFloat128Infinity(float128);
+extern int isFloat128Zero(float128);
+
+extern int isFloat128eq(float128, float128);
+extern int isFloat128lt(float128, float128);
+extern int isFloat128gt(float128, float128);
 
 #endif
Index: uspace/lib/softfloat/include/conversion.h
===================================================================
--- uspace/lib/softfloat/include/conversion.h	(revision e898296dccf506e7ddbab26d669ed48d920be059)
+++ uspace/lib/softfloat/include/conversion.h	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
@@ -1,4 +1,5 @@
 /*
  * Copyright (c) 2005 Josef Cejka
+ * Copyright (c) 2011 Petr Koupy
  * All rights reserved.
  *
@@ -30,5 +31,5 @@
  * @{
  */
-/** @file
+/** @file Conversion of precision and conversion between integers and floats.
  */
 
@@ -37,5 +38,12 @@
 
 extern float64 convertFloat32ToFloat64(float32);
+extern float128 convertFloat32ToFloat128(float32);
+extern float128 convertFloat64ToFloat128(float64);
+
+
 extern float32 convertFloat64ToFloat32(float64);
+extern float32 convertFloat128ToFloat32(float128);
+extern float64 convertFloat128ToFloat64(float128);
+
 
 extern uint32_t float32_to_uint32(float32);
@@ -45,9 +53,16 @@
 extern int64_t float32_to_int64(float32);
 
+extern uint32_t float64_to_uint32(float64);
+extern int32_t float64_to_int32(float64);
+
 extern uint64_t float64_to_uint64(float64);
 extern int64_t float64_to_int64(float64);
 
-extern uint32_t float64_to_uint32(float64);
-extern int32_t float64_to_int32(float64);
+extern uint32_t float128_to_uint32(float128);
+extern int32_t float128_to_int32(float128);
+
+extern uint64_t float128_to_uint64(float128);
+extern int64_t float128_to_int64(float128);
+
 
 extern float32 uint32_to_float32(uint32_t);
@@ -63,4 +78,10 @@
 extern float64 int64_to_float64(int64_t);
 
+extern float128 uint32_to_float128(uint32_t);
+extern float128 int32_to_float128(int32_t);
+
+extern float128 uint64_to_float128(uint64_t);
+extern float128 int64_to_float128(int64_t);
+
 #endif
 
Index: uspace/lib/softfloat/include/div.h
===================================================================
--- uspace/lib/softfloat/include/div.h	(revision e898296dccf506e7ddbab26d669ed48d920be059)
+++ uspace/lib/softfloat/include/div.h	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
@@ -1,4 +1,5 @@
 /*
  * Copyright (c) 2005 Josef Cejka
+ * Copyright (c) 2011 Petr Koupy
  * All rights reserved.
  *
@@ -30,5 +31,5 @@
  * @{
  */
-/** @file
+/** @file Division functions.
  */
 
@@ -38,6 +39,5 @@
 extern float32 divFloat32(float32, float32);
 extern float64 divFloat64(float64, float64);
-
-extern uint64_t divFloat64estim(uint64_t, uint64_t);
+extern float128 divFloat128(float128, float128);
 
 #endif
Index: uspace/lib/softfloat/include/mul.h
===================================================================
--- uspace/lib/softfloat/include/mul.h	(revision e898296dccf506e7ddbab26d669ed48d920be059)
+++ uspace/lib/softfloat/include/mul.h	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
@@ -1,4 +1,5 @@
 /*
  * Copyright (c) 2005 Josef Cejka
+ * Copyright (c) 2011 Petr Koupy
  * All rights reserved.
  *
@@ -30,5 +31,5 @@
  * @{
  */
-/** @file
+/** @file Multiplication functions.
  */
 
@@ -38,6 +39,5 @@
 extern float32 mulFloat32(float32, float32);
 extern float64 mulFloat64(float64, float64);
-
-extern void mul64integers(uint64_t, uint64_t, uint64_t *, uint64_t *);
+extern float128 mulFloat128(float128, float128);
 
 #endif
